package code.comet

import net.liftweb._
import http._
import actor._

import scala.xml.NodeSeq

object ChatServer extends LiftActor with ListenerManager {
  private var messages = Vector("Welcome")

  def createUpdate = messages

  override def lowPriority = {
    case s: String => 
      messages = messages :+ s
    updateListeners()
  }
}

class Chat extends CometActor with CometListener {
  private var messages: Vector[String] = Vector.empty

  def registerWith = ChatServer

  override def lowPriority = {
    case m: Vector[String] =>
      messages = m
    reRender()
  }

  def render = bind("chat", "line" -> line _)

  def line(html: NodeSeq): NodeSeq =
    messages.flatMap(m =>
      bind("chat", html, "message" -> m))
                     
}
